# Copyright (C) 2008 Red Hat, Inc

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# a long with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# Copyright (C) 2008 Red Hat, Inc

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# a long with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
require 'open-uri'

module GenomeSync
  class GitwebProxy
    attr_accessor :repo_regex

    def initialize(opts)
      @repo_regex = /.*/ # Match everything by default
      if opts[:url].nil?
        raise(ArgumentError, ":server or :url must be set") if opts[:server].nil?
        @url = default_gitweb_url(opts[:server])
      else
        @url = opts[:url]
      end
    end

    def repo_paths
      parse(fetch_paths).find_all {|p| repo_regex.match(p)}.map {|p| p.sub("/.git", "")}.sort
    end

    private
    def default_gitweb_url(server)
      "http://#{server}/git/gitweb.cgi?a=project_index"
    end

    def fetch_paths
      open(@url) do |f|
        # Sometimes gitweb attaches the owner's name of the repo.  The regex
        # should grab just the part we need.
        f.readlines
      end
    end

    def parse(lines)
      # Remove the owner
      lines.map {|line| line.strip.match(/([^\s]*)/)[1]}
    end
  end
end
